------------------------------------------------------------
-- Euphoria Light Cycles by Mike Howell and Chris Schenck --
------------------------------------------------------------
include get.e
include machine.e
include mouse.e
include graphics.e

constant object_time = 4-- Speed on obstacle placement
constant stuff = 100000 -- Animation delay (set this higher for slower speed)
atom dir1,dir2,         -- current direction of bikes
     done,              -- condition for main loop
     wins1,wins2,       -- tally of wins for bikes
     obstacles,         -- obstacles on or off (boolean)
     time1,time2        -- delay for obstacles
sequence bike1,bike2,   -- {{x-location,y-location},direction}
	 dirs           -- defines directions 1,2,3 and 4
object junk,            -- all-purpose temporary variable (gotta have one)
       working          -- current obstacle coordinates
-- Intro screen and choice of obstacles
procedure intro()
    position(10,30)
    text_color(BRIGHT_RED)
    puts(1,"EUPHORIA LIGHT CYCLES")
    position(12,24)
    puts(1,"by: Mike Howell and Chris Schenck")
    position(19,26)
    text_color(BRIGHT_WHITE)
    puts(1,"Do you want obstacles? (y/n): ")
    junk = wait_key()
    if junk = 'y' or junk = 'Y' then
	obstacles = 1
    else
	obstacles = 0
    end if
    clear_screen()
end procedure

-- Procedure to slow down the animation
procedure delayx()
    for i = 1 to stuff do end for
end procedure

-- Procedure to initialize the variables
procedure init()
    time1 = time()
    time2 = 0
    working = 0
    done = 0
    junk = get_mouse()
    dirs = {{0,-1},{1,0},{0,1},{-1,0}} -- 4 directions (up,right,down,left)
    clear_screen()
    bike1 = {{10,240},2} -- {{x-location,y-location},direction}
    bike2 = {{630,240},4}
    polygon(WHITE,0,{{0,0},{639,0},{639,479},{0,479}}) -- screen border
    mouse_events(LEFT_DOWN+RIGHT_DOWN)
    mouse_pointer(0)
end procedure

-- Procedure to check for player moves, gets a mouse move for player 1, then
-- a keyboard move for player 2
procedure get_move()
    junk = get_mouse() -- used to empty the buffer on replays, otherwise the
		       -- player 1 bike starts of going up or down sometimes
		       -- instead of to the right
    if sequence(junk) then
	dir1 = junk[1]
    else
	dir1 = -1
    end if
     dir2 = get_key()
end procedure

-- Procedure to check if either bike is about to collide with something
procedure check_move()
    if get_pixel(bike1[1]) then
	done = 1  -- player 1 lost
	wins2 = wins2 + 1
    end if
    if get_pixel(bike2[1]) then
	done = 2  -- player 2 lost
	wins1 = wins1 + 1
    end if
    if bike1[1][1] = bike2[1][1] and bike1[1][2] = bike2[1][2] then
	done = 3
    end if
end procedure

-- Main animation procedure
procedure draw_move()
    -- turning bike 1: cycles (to the left or right) though the "dirs" sequence
    if dir1 = 2 then
	bike1[2] = bike1[2] - 1
	if bike1[2] = 0 then
	    bike1[2] = 4
	end if
	bike1[1] = bike1[1] + dirs[bike1[2]]
    elsif dir1 = 8 then
	bike1[2] = bike1[2] + 1
	if bike1[2] = 5 then
	    bike1[2] = 1
	end if
	bike1[1] = bike1[1] + dirs[bike1[2]]
    else
	bike1[1] = bike1[1] + dirs[bike1[2]]
    end if
    --turning bike 2: cycles (to the left or right) through the "dirs" sequence
    if dir2 = 331 then
	bike2[2] = bike2[2] - 1
	if bike2[2] = 0 then
	    bike2[2] = 4
	end if
	bike2[1] = bike2[1] + dirs[bike2[2]]
    elsif dir2 = 333 then
	bike2[2] = bike2[2] + 1
	if bike2[2] = 5 then
	    bike2[2] = 1
	end if
	bike2[1] = bike2[1] + dirs[bike2[2]]
    else
	bike2[1] = bike2[1] + dirs[bike2[2]]
    end if
    -- if obstacles are turned on and the upcoming pixel is gray, turn it
    -- black to avoid colliding with incoming obstacles
    if obstacles then
	if get_pixel(bike1[1]) = GRAY then
	    pixel(BLACK,bike1[1])
	end if
	if get_pixel(bike2[1]) = GRAY then
	    pixel(BLACK,bike2[1])
	end if
    end if
    -- check for collision
    check_move()
    -- draw the new position assuming there is no collision
    pixel(BRIGHT_BLUE,bike1[1])
    pixel(GREEN,bike2[1])
end procedure

-- Procedure to place obstacles
procedure obstacle()
    -- if there is currently a gray obstacle on the screen, turn it red
    if sequence(working) then
	ellipse(RED,1,working[1],working[2])
	working = 0
    -- otherwise, start a new gray obstacle
    else
	junk = {rand(579),rand(419)}
	working = {junk,junk+60}
	ellipse(GRAY,1,working[1],working[2])
    end if
end procedure

-- Procedure to declare the winner and display the statistics
procedure end_game()
    text_color(MAGENTA)
    position(14,34)
    if done = 1 then
	puts(1,"Cycle 2 wins!\n")
    elsif done = 2 then
	puts(1,"Cycle 1 wins!\n")
    else
	puts(1,"  Tie game!\n")
    end if
    position(16,31)
    puts(1,"Another game? (y/n)")
    junk = wait_key()
    -- ignores left and right arrow so they won't be considered to be a "yes"
    -- on the continue question
    while junk = 331 or junk = 333 do
	junk = wait_key()
    end while
    if junk = 'n' or junk = 'N' then
	clear_screen()
	polygon(WHITE,0,{{0,0},{639,0},{639,479},{0,479}}) -- screen border
	position(8,20)
	text_color(RED)
	puts(1,"Thank you for playing Euphoria Light Cycles")
	position(12,30)
	text_color(BRIGHT_BLUE)
	printf(1,"%s %d %s",{"Player 1 won",wins1,"games"})
	position(13,30)
	text_color(GREEN)
	printf(1,"%s %d %s",{"Player 2 won",wins2,"games"})
	position(17,29)
	if wins1 > wins2 then
	    text_color(BRIGHT_BLUE)
	    puts(1,"Player 1 is the champ!")
	elsif wins2 > wins1 then
	    text_color(GREEN)
	    puts(1,"Player 2 is the champ!")
	else
	    position(17,33)
	    text_color(CYAN)
	    puts(1,"We have a tie!")
	end if
	position(21,33)
	text_color(RED)
	puts(1,"Press any key")
	junk = wait_key()
	junk = graphics_mode(-1) 
	abort(0)
    end if
end procedure

procedure main()
    init()
    -- main game loop
    while not done do
	delayx()
	get_move()
	draw_move()
	-- call obstacle procedure every 5 seconds
	if obstacles then
	    time2 = time()
	    if time2 - time1 > object_time then
		obstacle()
		time1 = time()
	    end if
	end if
    end while
    end_game()
    main()
end procedure

junk = graphics_mode(18)
intro()
-- these 2 following varibles are initialized outside of the main loop
wins1 = 0
wins2 = 0
main()
junk = graphics_mode(-1)

