-----------------------------------------------------------------------------
-- ######  #####     ###  ###      ** Euphoria Data Manipulation ** edm.E  **
-- ##      ##  ##    # #  # #      ------------------------------------------
-- ######  ##  ##   ## #### ##     -- Created by Ralf Nieuwenhuijsen       --
-- ##      ##  ##  ##   ##   ##    ------------------------------------------
-- ######  #####   ##   ##   ##    -- Edit, copy as you please but...      --
------------------------------------- ALWAYS keep my name somewhere        --   
------------------------------------- on top of the file.                  --
-----------------------------------------------------------------------------
--------------------------------------(I've spent too much time on this)-----
-----------------------------------------------------------------------------
-- Before you read on, i apologize for all there spelling errors and english 
--  language mistakes this file contains. I'm 14 years old and from Holland.
-----------------------------------------------------------------------------

-- Scramble/Encryption function                        By Ralf Nieuwenhuijsen
-----------------------------------------------------------------------------
-- use:       s3 = scramble (s1, s2) 
--
-- s3 is a result of a melting between s1 and s2
-- if you melt s3 with s2 you'll get s1
-- if you melt s3 with s1 you'll get s2
-- if you melt s2 with s1 you'll get s3
-- So if you know 2 of the 3 sequenceses the 3rd sequence will be the result.
--
-- example:  s3 = scramble ("This is my secret info","my password")
--           s2 = scramble ("This is my secret info", s3)  
--           s1 = scramble crypt (s3, s2)  
--           puts (1,s2)                --> (screen) my password
--           puts (1,s1)                --> (screen) this is my secret info
--
-- Warning: scramble ("info", "pass") is the same as scramble ("pass","info")
-- Warning: scramble ("infoinfoinfo","p" is the same as scramble("info","ppp")
-- Warning: it will hang is either s1 or s2 is nested. e.g. {'I',{'N','F'},'O'}
--             
-- Good for password systems
-- Uncrackable: every different s2 or s1 will result in a different s3
-----------------------------------------------------------------------------

-- Shrink & expand function                            By Ralf Nieuwenhuijsen
-----------------------------------------------------------------------------
-- use:  s2 = shrink(s1)  OR   s2 = shrink(a)
--
-- Result: binairy representation of an euphoria object, with data structure 
--          and a bit compressed.
--
-- use: s2 = expand(s1)
--
-- This will convert the binairy representation to an euphoria sequence ONLY
--  ( it will also restore the data structure)
-- 
-- Example:    s1 = {20,12,{457,{{30040},39},9}}
--             s2 = shrink(s1)
--             ? s2
--             s3 = expand(s2)
--
--    Now s2 will be something like {1,1,0,0,1,1,1,0,0,1,1,0,1,0,1,1,0,0}
--    And s3 will be equal to s1
--
-- Good for database programs, if you wrote an string representation of an
--   euphoria object into a file it would take up a lot of space, but with
--   a binaire representation that only uses the amount of bits it needs for 
--   data storage the file would be a LOT smaller.
--
-- Note: if you're gonna write the binaire representation to a file you must 
--  convert it first to bytes and then write it to a file opened for binairy
--  input/output because it might contain some control characters.
--  you can use bits_to_data to convert it to bytes (wich might contain control
--      characters) 
-- Warning: the number of bits that shrink returns can be any number. 
include machine.e
include get.e
function select_type(atom data)
sequence ret
    if data <= 15 then
	ret = {1,{0,0}}
    elsif data <= 255 then
	ret = {2,{0,1}}
    elsif data <= 65535 then
	ret = {3,{1,1,0}}
    elsif data <= 4294967295 then  
	ret = {4,{1,1,1,0}}
    else
	ret = {5,{1,1,1,1}}
    end if
    return ret
end function

function data_to_bits(sequence data)
sequence ret
    ret = ""
    for j=1  to length(data)  by 1 do
	ret = ret & int_to_bits(data[j],8)
    end for
    return ret
end function

function bits_to_data(sequence bits)
-- warning: it just converts it to bytes... you can use an euphoria routine!!
sequence ret
    ret =""
    for j=1  to length(bits) /8  by 1  do
	ret = ret & bits_to_int(bits[((j-1)*8)+1..((j-1)*8)+8])
    end for
    return ret
end function


function scramble(sequence data,sequence password)
atom tel
sequence ret
    if length(data) < length(password) then
	ret = data
	data = password
	password = ret
	ret = {}
    end if
    data = data_to_bits(data)
    password = data_to_bits(password)
    tel=1
    ret=repeat(0,length(data))
    for j=1  to length(data) do
	if password[tel] = 1 then ret[j] = not data[j] else ret[j] = data[j] end if
	tel = tel +1
	if tel > length(password) then tel=1 end if
    end for
	ret = bits_to_data(ret)
    return ret
end function

function count_mark_type(atom data)
sequence ret
    if data <= 15 then
	ret = {1,0,0,0,0}
    elsif data <= 255 then
	ret = {0,1,0,0,0} 
    elsif data <= 65535 then
	ret = {0,0,1,0,0}
    elsif data <= 4294967295 then  
	ret = {0,0,0,1,0}
    else
	ret = {0,0,0,0,1}
    end if
    return ret
end function

function add_data(atom data)
object ret
    if data <= 15 then
	ret = 4
    elsif data <= 255 then
	ret = 8 
    elsif data <= 65536 then
	ret = 16
    elsif data <= 4294967295 then  
	ret = 32
    else
	ret = 64
    end if
    ret = int_to_bits (data,ret)
    return ret
end function

function shrink_sequence(sequence data)
sequence ret,chk,st_type,tp
atom chk_old
    ret = {1,1,0,0}
    chk = {0,0,0,0,0}
    for j=1  to length(data)  by 1  do
	if not sequence(data[j]) then
	    chk = chk + count_mark_type(data[j])
	end if
    end for
    chk_old = 1
    for j=2  to 5  by 1  do
	if chk[j] > chk[chk_old] then
	    chk_old = j
	end if
    end for
    st_type = {0}
    if chk_old = 1 then
	st_type[1] = 1
	ret = ret & {0,0}
    elsif chk_old = 2 then
	st_type[1] = 2
	ret = ret & {0,1}
    elsif chk_old = 3 then
	st_type[1] = 3
	ret = ret & {1,0}
    elsif chk_old = 4 then
	st_type[1] = 4
	ret = ret & {1,1,0}
    else
	st_type[1] = 5
	ret = ret & {1,1,1}
    end if
    for j=1  to length(data)  by 1  do
	if sequence(data[j]) then
	    ret= ret & shrink_sequence(data[j])
	else
	    tp = select_type(data[j])
	    if tp[1] = st_type[1] then
		ret = ret & {0} & add_data(data[j])
	    else
		ret = ret & {1} & tp[2] & add_data(data[j])
	    end if
	end if
    end for
    ret = ret & {1,1,0,1}
    return ret
end function

global function shrink(object data)
sequence ret
    if not sequence(data) then
	data = {data}
    end if
    ret = shrink_sequence(data)
    return ret
end function

global function expand(sequence data)
sequence ret,st
atom j, level
    ret = ""
    st=""
    j = 1
    level = 0
    while j <= length(data) do
    if data[j]=0 then               
	j=j+1
	trace(1)
	ret = ret & " " & sprintf("%f",bits_to_int(data[j..j+st[level]-1])) &","
	j=j+st[level]
    else
	j=j+1
	if data[j]=0 then       
	    j=j+1
	    if data[j]=0 then
	      j=j+1
	      ret=ret & " " & sprintf("%f",bits_to_int(data[j..j+3])) & " ,"
	      j=j+4
	    else
	      j=j+1
	      ret = ret & " " & sprintf("%f",bits_to_int(data[j..j+7])) & " ,"
	      j=j+8
	    end if
	else
	    j=j+1
	    if data[j]=0 then
		j=j+1
		if data[j]=0 then
		    j=j+1
		    ret = ret & " {"
		    level = level + 1
		    if data[j]=0 then
			j=j+1
			if data[j]=0 then
			    j=j+1
			    st = st & 4
			else
			    j=j+1
			    st = st & 8
			end if
		    else
			j=j+1
			if data[j]=0 then
			    j=j+1
			    st = st & 16
			else
			    j=j+1
			    if data[j]=0 then
				j=j+1
				st = st & 32
			    else
				j=j+1
				st = st & 64
			    end if
			end if
		    end if
		else
		    j=j+1
		    ret[length(ret)] = ' '
		    ret = ret & "}"
		    ret = ret & " ,"
		    
		    level = level - 1
		    st=st[1..length(st)-1]
		end if
	    else
		j=j+1
		if data[j]=0 then
		  j=j+1
		  ret=ret & " " & sprintf("%f",bits_to_int(data[j..j+15])) & ","
		  j=j+16
		else
		    j=j+1
		    if data[j]=0 then
		    j=j+1
		    ret=ret &" " &sprintf("%f",bits_to_int(data[j..j+31])) & ","
		    j=j+32
		    else
		    j=j+1
		    ret=ret &" "&sprintf("%f",bits_to_int(data[j..j+63])) & ","
		    j=j+64
		    end if
		end if
	    end if
	end if
    end if
    
    end while
    ret = value(ret[1..length(ret)-1])
    return ret[2]
end function

function create_bitlist( sequence bits)
sequence ret
    ret = {" "}
    for j=1  to length(bits)-8  by 8  do
	ret = ret & bits_to_int(bits[j..j+7])
    end for
    ret[1] = length(bits)-(length(ret[2..length(ret)])*8)
    if not ret[1] = 0 then
    ret = ret & bits_to_int(bits[length(bits)-ret[1]+1..length(bits)])
    else
    ret = ret & bits_to_int(bits[length(bits)-ret[1]+1..length(bits)])
    end if
return ret
end function

function read_bitlist(sequence list)
sequence ret
    ret = ""
    for j=2 to length(list)-1  by 1 do
	ret = ret & int_to_bits(list[j],8)
    end for
    if not list[1] = 0 then
	ret = ret & int_to_bits(list[length(list)],list[1])
    else
	ret = ret & int_to_bits(list[length(list)],8)
    end if
    return ret
end function



