
;                             LISP Bubble Sort
;                             by Gregg Guarnera
;                                Reston, VA


;       Format   :   (Sort <list> <pred>)
;                              <list>   =   list to be sorted
;                              <pred>   =   predicate to sort by,
;                                           must be a function that takes
;                                           two parameters to compare,
;                                           (e.g.  '(<= x y)   )
;                               Returns :   The list sorted according to
;                                           the sorting predicate.




(defun sort (ls pred)
  (cond ((<= (length ls) 1) nil)

       (t (prog*   (     (n    (-  (length ls) 2))
                         (i    0 )
                         (ls2  nil)       )
          Loopx

            ( cond  ((funcall pred
                         (nth i ls)
                         (nth (1+ i) ls)
                    )
                   (setq ls2 ( append ls2 (list (nth i ls))) )
                   (setq ls (append
                             ls2
                             (list (nth (1+ i) ls) )
                             (nthcdr (+ 2 i) ls)
                             )     ;append
                          )      ;setq
                 )
              (t
                 (setq ls2 ( append ls2 (list (nth (1+ i) ls))) )
                 (setq ls (append
                             ls2
                             (list (nth i ls))
                             (nthcdr (+ 2 i) ls)
                             )
                          ) ;setq
                 )
              );cond
              (cond ((equal i n) (return ls)) )
              (setq i (1+ i))
              (go loopx)
        );prog
        (Setq ls (append (sort   (reverse (cdr (reverse ls)))   pred)
                         (list (nth (1- (length ls)) ls))
                         );append
                 );setq
             ); t
       );cond
       (cond (t ls))
   );defun